/* Generated by wayland-scanner 1.20.0 */

#ifndef QT_TEXTURE_SHARING_UNSTABLE_V1_SERVER_PROTOCOL_H
#define QT_TEXTURE_SHARING_UNSTABLE_V1_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_qt_texture_sharing_unstable_v1 The qt_texture_sharing_unstable_v1 protocol
 * @section page_ifaces_qt_texture_sharing_unstable_v1 Interfaces
 * - @subpage page_iface_zqt_texture_sharing_v1 - 
 * @section page_copyright_qt_texture_sharing_unstable_v1 Copyright
 * <pre>
 *
 * Copyright (C) 2019 The Qt Company Ltd.
 * Contact: http://www.qt.io/licensing/
 *
 * This file is part of the plugins of the Qt Toolkit.
 *
 * $QT_BEGIN_LICENSE:BSD$
 * You may use this file under the terms of the BSD license as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 * </pre>
 */
struct qt_server_buffer;
struct zqt_texture_sharing_v1;

#ifndef ZQT_TEXTURE_SHARING_V1_INTERFACE
#define ZQT_TEXTURE_SHARING_V1_INTERFACE
/**
 * @page page_iface_zqt_texture_sharing_v1 zqt_texture_sharing_v1
 * @section page_iface_zqt_texture_sharing_v1_api API
 * See @ref iface_zqt_texture_sharing_v1.
 */
/**
 * @defgroup iface_zqt_texture_sharing_v1 The zqt_texture_sharing_v1 interface
 */
extern const struct wl_interface zqt_texture_sharing_v1_interface;
#endif

/**
 * @ingroup iface_zqt_texture_sharing_v1
 * @struct zqt_texture_sharing_v1_interface
 */
struct zqt_texture_sharing_v1_interface {
	/**
	 */
	void (*request_image)(struct wl_client *client,
			      struct wl_resource *resource,
			      const char *key);
	/**
	 */
	void (*abandon_image)(struct wl_client *client,
			      struct wl_resource *resource,
			      const char *key);
};

#define ZQT_TEXTURE_SHARING_V1_IMAGE_FAILED 0
#define ZQT_TEXTURE_SHARING_V1_PROVIDE_BUFFER 1

/**
 * @ingroup iface_zqt_texture_sharing_v1
 */
#define ZQT_TEXTURE_SHARING_V1_IMAGE_FAILED_SINCE_VERSION 1
/**
 * @ingroup iface_zqt_texture_sharing_v1
 */
#define ZQT_TEXTURE_SHARING_V1_PROVIDE_BUFFER_SINCE_VERSION 1

/**
 * @ingroup iface_zqt_texture_sharing_v1
 */
#define ZQT_TEXTURE_SHARING_V1_REQUEST_IMAGE_SINCE_VERSION 1
/**
 * @ingroup iface_zqt_texture_sharing_v1
 */
#define ZQT_TEXTURE_SHARING_V1_ABANDON_IMAGE_SINCE_VERSION 1

/**
 * @ingroup iface_zqt_texture_sharing_v1
 * Sends an image_failed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zqt_texture_sharing_v1_send_image_failed(struct wl_resource *resource_, const char *key, const char *error_message)
{
	wl_resource_post_event(resource_, ZQT_TEXTURE_SHARING_V1_IMAGE_FAILED, key, error_message);
}

/**
 * @ingroup iface_zqt_texture_sharing_v1
 * Sends an provide_buffer event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zqt_texture_sharing_v1_send_provide_buffer(struct wl_resource *resource_, struct wl_resource *buffer, const char *key)
{
	wl_resource_post_event(resource_, ZQT_TEXTURE_SHARING_V1_PROVIDE_BUFFER, buffer, key);
}

#ifdef  __cplusplus
}
#endif

#endif
